VSTGUI 4.5 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
CGradientView Class Reference
Version 4.2

View which draws a gradient. More...

Inheritance diagram for CGradientView:

## Public Member Functions
| CGradientView (const CRect &size)
| ~CGradientView () noexceptoverride=default
void | setViewSize (const CRect &rect, bool invalid=true) override
| set views size More...
void | draw (CDrawContext *context) override
| called if the view should draw itself More...
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes More...
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes More...
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| called when a mouse down event occurs More...
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| called when a mouse up event occurs More...
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| called when a mouse move event occurs More...
virtual CMouseEventResult | onMouseCancel ()
| called when mouse tracking should be canceled More...
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| called when the mouse enters this view More...
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| called when the mouse leaves this view More...
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons=-1)
| check if where hits this view More...
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons)
| called if a mouse wheel event is happening over this view More...
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
| called if a mouse wheel event is happening over this view More...
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view More...
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not More...
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse More...
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse More...
const CRect & | getMouseableArea () const
| read only access to the mouseable area More...
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation More...
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling More...
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target More...
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown More...
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus More...
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus More...
CCoord | getHeight () const
| get the height of the view More...
CCoord | getWidth () const
| get the width of the view More...
const CRect & | getViewSize () const
| read only access to view size More...
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view More...
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size More...
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates More...
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates More...
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags More...
int32_t | getAutosizeFlags () const
| get autosize flags More...
virtual bool | sizeToFit ()
| resize view to optimal size More...
virtual void | looseFocus ()
| called if view should loose focus More...
virtual void | takeFocus ()
| called if view should take focus More...
virtual bool | wantsFocus () const
| check if view supports focus More...
virtual void | setWantsFocus (bool state)
| set focus support on/off More...
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute More...
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute More...
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute More...
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute More...
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute More...
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute More...
virtual void | setBackground (CBitmap *background)
| set the background image of this view More...
CBitmap * | getBackground () const
| get the background image of this view More...
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled More...
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled More...
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state. More...
virtual void | setTransparency (bool val)
| set views transparent state More...
bool | getTransparency () const
| get views transparent state More...
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view More...
float | getAlphaValue () const
| get alpha value More...
virtual bool | removed (CView *parent)
| view is removed from parent view More...
virtual bool | attached (CView *parent)
| view is attached to a parent view More...
bool | isAttached () const
| is view attached to a parentView More...
CView * | getParentView () const
| get parent view More...
CFrame * | getFrame () const
| get frame More...
virtual VSTGUIEditorInterface * | getEditor () const
| get editor More...
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject=nullptr)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform () const
| get the active global transform for this view More...
template<typename T >
T & | translateToGlobal (T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T | translateToGlobal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T & | translateToLocal (T &t) const
| translates a global coordinate to a local one using parent transforms More...
template<typename T >
T | translateToLocal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself More...
virtual bool | checkUpdate (const CRect &updateRect) const
virtual bool | isDirty () const
| check if view is dirty More...
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle. More...
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid More...
virtual void | invalid ()
| mark whole view as invalid More...
virtual void | setVisible (bool state)
| set visibility state More...
bool | isVisible () const
| get visibility state More...
virtual void | onIdle ()
| called on idle when view wants idle More...
void | setWantsIdle (bool state)
| enable/disable onIdle() callback More...
bool | wantsIdle () const
| returns if the view wants idle callback or not More...
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &o)
CBaseObject & | operator= (const CBaseObject &obj)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0 More...
void | remember () override
| increase refcount More...
virtual int32_t | getNbReference () const
| get refcount More...

## Protected Member Functions
virtual void | attributeChanged ()
Protected Member Functions inherited from CView
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Protected Attributes
GradientStyle | gradientStyle {kLinearGradient}
CColor | frameColor {kBlackCColor}
double | gradientAngle {0.}
CCoord | roundRectRadius {5.}
CCoord | frameWidth {1.}
CCoord | radialRadius {1.}
CPoint | radialCenter {0.5, 0.5}
bool | drawAntialiased {true}
SharedPointer< CGraphicsPath > | path
SharedPointer< CGradient > | gradient

## Gradient Style Methods
enum | GradientStyle { kLinearGradient, kRadialGradient }
void | setGradientStyle (GradientStyle style)
void | setGradient (CGradient *gradient)
void | setFrameColor (const CColor &newColor)
void | setGradientAngle (double angle)
void | setRoundRectRadius (CCoord radius)
void | setFrameWidth (CCoord width)
void | setDrawAntialiased (bool state)
void | setRadialCenter (const CPoint &center)
void | setRadialRadius (CCoord radius)
GradientStyle | getGradientStyle () const
CGradient * | getGradient () const
const CColor & | getFrameColor () const
double | getGradientAngle () const
CCoord | getRoundRectRadius () const
CCoord | getFrameWidth () const
bool | getDrawAntialised () const
const CPoint & | getRadialCenter () const
CCoord | getRadialRadius () const

## Additional Inherited Members
Public Types inherited from CView
enum | MouseListenerCall { MouseDown, MouseMoved, MouseUp, MouseCancel }
Static Public Attributes inherited from CView
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle. More...
static uint32_t | idleRate
| global idle rate in Hz, defaults to 30 Hz More...
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0, kTransparencyEnabled = 1 << 1, kWantsFocus = 1 << 2, kIsAttached = 1 << 3, kVisible = 1 << 4, kDirty = 1 << 5, kWantsIdle = 1 << 6, kIsSubview = 1 << 7, kLastCViewFlag = 7 }

## Detailed Description

View which draws a gradient.

## Member Enumeration Documentation

enum GradientStyle

Enumerator
kLinearGradient |
kRadialGradient |

## Constructor & Destructor Documentation

CGradientView | ( | const CRect & | size | ) |
| explicit

~CGradientView | ( |  | ) |
| override default noexcept

## Member Function Documentation

void attributeChanged | ( |  | ) |
| protected virtual

void draw | ( | CDrawContext * | pContext | ) |
| override virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented from CView.

bool getDrawAntialised | ( |  | ) | const
| inline

const CColor& getFrameColor | ( |  | ) | const
| inline

CCoord getFrameWidth | ( |  | ) | const
| inline

CGradient* getGradient | ( |  | ) | const
| inline

double getGradientAngle | ( |  | ) | const
| inline

GradientStyle getGradientStyle | ( |  | ) | const
| inline

const CPoint& getRadialCenter | ( |  | ) | const
| inline

CCoord getRadialRadius | ( |  | ) | const
| inline

CCoord getRoundRectRadius | ( |  | ) | const
| inline

void setDrawAntialiased | ( | bool | state | ) |

void setFrameColor | ( | const CColor & | newColor | ) |

void setFrameWidth | ( | CCoord | width | ) |

void setGradient | ( | CGradient * | gradient | ) |

void setGradientAngle | ( | double | angle | ) |

void setGradientStyle | ( | GradientStyle | style | ) |

void setRadialCenter | ( | const CPoint & | center | ) |

void setRadialRadius | ( | CCoord | radius | ) |

void setRoundRectRadius | ( | CCoord | radius | ) |

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = `true`
| ) |  |
| override virtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented from CView.

## Member Data Documentation

bool drawAntialiased {true}
| protected

CColor frameColor {kBlackCColor}
| protected

CCoord frameWidth {1.}
| protected

SharedPointer<CGradient> gradient
| protected

double gradientAngle {0.}
| protected

GradientStyle gradientStyle {kLinearGradient}
| protected

SharedPointer<CGraphicsPath> path
| protected

CPoint radialCenter {0.5, 0.5}
| protected

CCoord radialRadius {1.}
| protected

CCoord roundRectRadius {5.}
| protected

The documentation for this class was generated from the following files:

- cgradientview.h
- cgradientview.cpp